 {$M $800,0,0}

 uses tsr,crt,dos;

 const alt : byte = $8;
       f12 : byte = $58;
       sloupec_t = 1;
       radek_t = 1;
       sloupcu_t = 34;
       radku_t = 12;
       hex_nums : array [0..15] of char = ('0','1','2','3','4','5','6','7',
                                           '8','9','A','B','C','D','E','F');

 type scr_s_t = array [1..sloupcu_t] of word;
      scr_t = array [1..radku_t] of scr_s_t;
      hexwordstr = string[2];


 var ch,ch_t,curx,cury,poz_t,videomode,x1,y1,x2,y2,l1,l2,hodn : byte;
     reg : registers;
     param : boolean;
     tab_seg,tab_ofs : word;
     screen_t : ^scr_s_t;
     savescr_t : scr_t;

 function dec_to_hex (dec : byte) : hexwordstr;

 begin
  dec_to_hex := hex_nums[dec shr 4] + hex_nums[dec - ((dec shr 4) shl 4)];
 end;

 procedure cursor (state : boolean);

 begin
  with reg do
   case state of
    true : begin ah := 1; ch := 0; cl := 31; end;
    false : begin ah := 1; ch := 12; cl := 13; end;
   end;
  intr ($10,reg);
 end;

 procedure box (x,y : byte);

 begin
  x1 := sloupec_t; x2 := x1 + x - 1; y1 := radek_t; y2 := y1 + y - 1;
  textbackground (7); textcolor (15); window (x1,y1,x2,y2); clrscr;
  window (x1,y1,x2 + 1,y2 + 1);
  for l1 := 2 to x - 1 do
   begin gotoxy (l1,1); write (''); gotoxy (l1,y); write (''); end;
  for l2 := 2 to y - 1 do
   begin gotoxy (1,l2); write (''); gotoxy (x,l2); write (''); end;
  gotoxy (1,1); write (''); gotoxy (x,1); write (''); gotoxy (1,y);
  write (''); gotoxy (x,y); write ('');
  for l1 := 2 to x - 1 do
   begin gotoxy (l1,10); write (''); end;
  gotoxy (1,10); write (''); gotoxy (x,10); write ('');
  gotoxy (((sloupcu_t - 16) shr 1) + 1,1); write (' ASCII  Tabulka ');
  for l2 := 2 to 9 do
   for l1 := 2 to 33 do
    begin
     hodn := (l2 - 2) * 32 + l1 - 2;
     mem[tab_seg:((l2 - 1) * 160 + (l1 - 1) * 2)] := hodn;
     mem[tab_seg:((l2 - 1) * 160 + (l1 - 1) * 2) + 1] := $70;
    end;
  textcolor (0); gotoxy (5,11); write ('Znak: '); gotoxy (16,11);
  write ('slo:     (  )'); mem[tab_seg:1620] := poz_t;
  mem[tab_seg:1621] := $70; gotoxy (23,11);
  case poz_t of
        0..9 : write ('  ');
        10..99 : write (' ');
       end;
  write (poz_t); gotoxy (28,11); write (dec_to_hex (poz_t));
  window (1,1,80,25);
  gotoxy (poz_t - (poz_t shr 5) shl 5 + 2,(poz_t shr 5) + 2);
 end;

 procedure show (on : boolean);

 begin
   for l1 := 1 to radku_t do
    begin
     screen_t := ptr (tab_seg,tab_ofs + (l1 - 1) * 160);
     if on = true then savescr_t[l1] := screen_t^
     else screen_t^ := savescr_t[l1];
    end;
 end;

 procedure tabulka;

 begin
  tab_ofs := ((radek_t - 1) * 80 + sloupec_t - 1) * 2;
  reg.ah := $0F; intr ($10,reg); videomode := reg.al;
  case videomode of
   7 : tab_seg := $B000 + reg.bh * $2000;
   2,3 : tab_seg := $B800 + reg.bh * $2000;
  end;
  screen_t := ptr (tab_seg,tab_ofs);
  if (videomode = 7) or (videomode in [2..3]) then
   begin
    curx := wherex; cury := wherey; cursor (true); show (true);
    box (sloupcu_t,radku_t);
    repeat
     ch_t := port [$60];
     if (ch_t = $48) or (ch_t = $50) or (ch_t = $4B) or (ch_t = $4D) or
        (ch_t = $1C) then
      begin
       case ch_t of
        $48 : dec (poz_t,32);
        $50 : inc (poz_t,32);
        $4B : dec (poz_t);
        $4D : inc (poz_t);
        $1C : begin
               gotoxy (curx,cury);
               reg.ah := $5; reg.ch := $39; reg.cl := poz_t; intr ($16,reg);
              end;
       end;
       mem[tab_seg:1620] := poz_t; gotoxy (23,11);
       case poz_t of
        0..9 : write ('  ');
        10..99 : write (' ');
       end;
       write (poz_t); gotoxy (28,11); write (dec_to_hex (poz_t));
       gotoxy (poz_t - (poz_t shr 5) shl 5 + 2,(poz_t shr 5) + 2);
       delay (100);
      end;
    until (ch_t = $1) or (ch_t = $1C);
    gotoxy (curx,cury); cursor (false); show (false);
   end;
 end;

 {$F+}

 procedure ovladac;

 begin
  ch := port[$60];
  if (ch = f12) and ((alt and mem[$40:$17]) = alt) then
   begin
    asm pushf end; oldintprog; mem[$40:$17] := mem[$40:$17] xor alt;
    tabulka;
   end
  else
   begin
    asm pushf end; oldintprog;
   end;
 end;

 {$F-}

begin
 if (paramstr (1) = '/o') or (paramstr (1) = '/O') then param := true;
 ident_tsr := 'TABULKA'; poz_t := 0;
 zavadec_tsr ($9,ovladac,false,false);
 if (not is_there) then
  begin
   if param then writeln ('Program nen rezidentn v pamti !');
   if (not param) then
    begin
     write (#13#10,
            'CHART je rezidentn program pro vloen znaku z ASCII tabulky .',#13#10,
            'Aktivuje se kombinac klves Alt+F12 .',#13#10,
            'Odinstalovn z pamti -> parametr /o .',#13#10#13#10,
            '                                               Copyright (C) 1998 by Jan Outrata',#13#10#13#10);
     zavadec_tsr ($9,ovladac,true,false);
    end;
  end;
 if is_there then
  if (paramstr (1) = '/o') or (paramstr (1) = '/O') then
   begin
    writeln (#13#10,
             'Dkuji Vm za pouit programu CHART .',#13#10#13#10,
             'Jan Outrata, e-mail: outrataj@alpha.inf.upol.cz, tel.: 068/5947751',#13#10);
    zavadec_tsr ($9,ovladac,false,true);
   end
  else writeln (#13#10,'Program je ji rezidentn v pamti.');
end.